(* Checker *)

exception Not_satisfied of string;;

let sf = Printf.sprintf;;

let check problem solution =
  let m = List.length solution in
  let h = Hashtbl.create m in
  List.iter (fun v -> Hashtbl.add h v true) solution;
  List.iter
    begin fun (literals,reasons) ->
      if not
        (List.exists
          begin fun (polarity,variable) ->
            polarity = Hashtbl.mem h variable
          end
          literals)
      then
        begin
          raise
            (Not_satisfied(
              sf "Clause (%s) not satisfied"
              (String.concat " "
                (List.map (fun (p,v) -> if p then v else "!"^v) literals))))
        end
    end
    problem
;;
